
var ftModule = angular.module('ft', []);
ftModule.factory('navigation', function($window, $http, $q) {
  return new PushStateNavigator($window, $http, $q);
});

function FlyThroughCtrl() {}

FlyThroughCtrl.prototype.initialize = function FlyThroughCtrl_initialize($scope, navigation) {
  var self = this;
  this.scope = $scope;
  $scope.goto = function(url) {
    navigation.goto(url);
  }
  
  navigation.onArrival(function(data) {self.arrive(data)});
};

FlyThroughCtrl.prototype.arrive = function FlyThroughCtrl_arrive(data) {
  if (this.scope.$$phase) {
    this.update(data);
  } else {
    var self = this;
    this.scope.$apply(function() {self.update(data);});
  }
};



function MapCtrl($scope, navigation) {
  this.initialize($scope, navigation);
  $scope.scenes = [];
  $scope.visible = false;
}

MapCtrl.prototype = new FlyThroughCtrl();

MapCtrl.prototype.update = function MapCtrl_update(data) {
  if (typeof data.map == 'object') {
    this.show(data.map);
  } else {
    this.hide();
  }
};

MapCtrl.prototype.show = function MapCtrl_show(map) {
  this.scope.scenes = map.scenes;
  this.scope.visible = true;
};

MapCtrl.prototype.hide = function MapCtrl_hide() {
  this.scope.visible = false;
};



function SceneCtrl($scope, navigation) {
  $scope.name = '';
  $scope.visible = false;
  this.initialize($scope, navigation);
}

SceneCtrl.prototype = new FlyThroughCtrl();

SceneCtrl.prototype.update = function SceneCtrl_update(data) {
  if (typeof data.scene == 'object') {
    this.show(data.scene);
  } else {
    this.hide();
  }
};

SceneCtrl.prototype.show = function SceneCtrl_show(scene) {
  this.scope.name = scene.name;
  this.scope.visible = true;
 };

 SceneCtrl.prototype.hide = function SceneCtrl_hide() {
   this.scope.visible = false;
 };



function UserCtrl($scope, $http, navigation) {
  $scope.loggedIn = false;
  $scope.username = '';
  $scope.password = '';
  $scope.message = '';
  $scope.login = angular.bind(this, this.login);
  this.http = $http;
  this.initialize($scope, navigation);
}

UserCtrl.prototype = new FlyThroughCtrl();

UserCtrl.prototype.update = function UserCtrl_update(data) {
  this.loginUrl = data.user.url;
  if (data.user.name) {
    this.scope.loggedIn = true;
    this.scope.username = data.user.name;
  } else {
    this.scope.loggedIn = false;
    this.scope.username = null;
  }
};

UserCtrl.prototype.login = function UserCtrl_login() {
  var self = this;
  this.http({
    method: 'POST',
    url: this.loginUrl,
    data: {username: this.scope.username, password: this.scope.password}
  }).success(function(data, status, header) {
    var location = header('Location');
    self.scope.goto(location);
  }).error(function(data, status, header) {
    if (status == 401) {
      self.scope.message = 'Incorrect username or password';
    } else {
      self.scope.message = 'Authentication failed'
    }
  });
};
